# Simulate card tap

> `POST https://api.kustom.co/ipp/v1/dev/sessions/{sessionId}/simulate-tap`

Simulates a physical card tap on the terminal reader, bypassing the need for real hardware. Uses Stripe test helpers to simulate a card-present payment with the requested outcome. Only available in non-production environments.

## Parameters

- `sessionId` (string, path, required)
- `outcome` (string, query) Enum: `SUCCESS`, `DECLINED_GENERIC`, `INSUFFICIENT_FUNDS`, `LOST_CARD`, `STOLEN_CARD`, `EXPIRED_CARD`, `INCORRECT_CVC`, `PROCESSING_ERROR`, `INCORRECT_NUMBER`, `CARD_VELOCITY_EXCEEDED`.

## Responses

### 204

Card tap simulated successfully.

### 400

Session has no terminal payment attached.

### 404

Session not found.
